gitweb: Link (HEAD) tree for each project from projects list
[git/dscho.git] / t / test-lib.sh
blobe2629339d4b1c9acf8cdf002f8ac59ef736eacf3
1 #!/bin/sh
3 # Copyright (c) 2005 Junio C Hamano
6 # For repeatability, reset the environment to known value.
7 LANG=C
8 LC_ALL=C
9 PAGER=cat
10 TZ=UTC
11 export LANG LC_ALL PAGER TZ
12 EDITOR=:
13 VISUAL=:
14 unset AUTHOR_DATE
15 unset AUTHOR_EMAIL
16 unset AUTHOR_NAME
17 unset COMMIT_AUTHOR_EMAIL
18 unset COMMIT_AUTHOR_NAME
19 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
20 unset GIT_AUTHOR_DATE
21 GIT_AUTHOR_EMAIL=author@example.com
22 GIT_AUTHOR_NAME='A U Thor'
23 unset GIT_COMMITTER_DATE
24 GIT_COMMITTER_EMAIL=committer@example.com
25 GIT_COMMITTER_NAME='C O Mitter'
26 unset GIT_DIFF_OPTS
27 unset GIT_DIR
28 unset GIT_EXTERNAL_DIFF
29 unset GIT_INDEX_FILE
30 unset GIT_OBJECT_DIRECTORY
31 unset SHA1_FILE_DIRECTORIES
32 unset SHA1_FILE_DIRECTORY
33 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
34 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
35 export EDITOR VISUAL
37 case $(echo $GIT_TRACE |tr [A-Z] [a-z]) in
38 1|2|true)
39 echo "* warning: Some tests will not work if GIT_TRACE" \
40 "is set as to trace on STDERR ! *"
41 echo "* warning: Please set GIT_TRACE to something" \
42 "other than 1, 2 or true ! *"
44 esac
46 # Each test should start with something like this, after copyright notices:
48 # test_description='Description of this test...
49 # This test checks if command xyzzy does the right thing...
50 # '
51 # . ./test-lib.sh
53 error () {
54 echo "* error: $*"
55 trap - exit
56 exit 1
59 say () {
60 echo "* $*"
63 test "${test_description}" != "" ||
64 error "Test script did not set test_description."
66 while test "$#" -ne 0
68 case "$1" in
69 -d|--d|--de|--deb|--debu|--debug)
70 debug=t; shift ;;
71 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
72 immediate=t; shift ;;
73 -h|--h|--he|--hel|--help)
74 echo "$test_description"
75 exit 0 ;;
76 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
77 verbose=t; shift ;;
78 --no-python)
79 no_python=t; shift ;;
81 break ;;
82 esac
83 done
85 exec 5>&1
86 if test "$verbose" = "t"
87 then
88 exec 4>&2 3>&1
89 else
90 exec 4>/dev/null 3>/dev/null
93 test_failure=0
94 test_count=0
96 trap 'echo >&5 "FATAL: Unexpected exit with code $?"; exit 1' exit
99 # You are not expected to call test_ok_ and test_failure_ directly, use
100 # the text_expect_* functions instead.
102 test_ok_ () {
103 test_count=$(expr "$test_count" + 1)
104 say " ok $test_count: $@"
107 test_failure_ () {
108 test_count=$(expr "$test_count" + 1)
109 test_failure=$(expr "$test_failure" + 1);
110 say "FAIL $test_count: $1"
111 shift
112 echo "$@" | sed -e 's/^/ /'
113 test "$immediate" = "" || { trap - exit; exit 1; }
117 test_debug () {
118 test "$debug" = "" || eval "$1"
121 test_run_ () {
122 eval >&3 2>&4 "$1"
123 eval_ret="$?"
124 return 0
127 test_expect_failure () {
128 test "$#" = 2 ||
129 error "bug in the test script: not 2 parameters to test-expect-failure"
130 say >&3 "expecting failure: $2"
131 test_run_ "$2"
132 if [ "$?" = 0 -a "$eval_ret" != 0 ]
133 then
134 test_ok_ "$1"
135 else
136 test_failure_ "$@"
140 test_expect_success () {
141 test "$#" = 2 ||
142 error "bug in the test script: not 2 parameters to test-expect-success"
143 say >&3 "expecting success: $2"
144 test_run_ "$2"
145 if [ "$?" = 0 -a "$eval_ret" = 0 ]
146 then
147 test_ok_ "$1"
148 else
149 test_failure_ "$@"
153 test_expect_code () {
154 test "$#" = 3 ||
155 error "bug in the test script: not 3 parameters to test-expect-code"
156 say >&3 "expecting exit code $1: $3"
157 test_run_ "$3"
158 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
159 then
160 test_ok_ "$2"
161 else
162 test_failure_ "$@"
166 # Most tests can use the created repository, but some amy need to create more.
167 # Usage: test_create_repo <directory>
168 test_create_repo () {
169 test "$#" = 1 ||
170 error "bug in the test script: not 1 parameter to test-create-repo"
171 owd=`pwd`
172 repo="$1"
173 mkdir "$repo"
174 cd "$repo" || error "Cannot setup test environment"
175 "$GIT_EXEC_PATH/git" init-db --template=$GIT_EXEC_PATH/templates/blt/ 2>/dev/null ||
176 error "cannot run git init-db -- have you built things yet?"
177 mv .git/hooks .git/hooks-disabled
178 cd "$owd"
181 test_done () {
182 trap - exit
183 case "$test_failure" in
185 # We could:
186 # cd .. && rm -fr trash
187 # but that means we forbid any tests that use their own
188 # subdirectory from calling test_done without coming back
189 # to where they started from.
190 # The Makefile provided will clean this test area so
191 # we will leave things as they are.
193 say "passed all $test_count test(s)"
194 exit 0 ;;
197 say "failed $test_failure among $test_count test(s)"
198 exit 1 ;;
200 esac
203 # Test the binaries we have just built. The tests are kept in
204 # t/ subdirectory and are run in trash subdirectory.
205 PATH=$(pwd)/..:$PATH
206 GIT_EXEC_PATH=$(pwd)/..
207 export PATH GIT_EXEC_PATH
209 # Similarly use ../compat/subprocess.py if our python does not
210 # have subprocess.py on its own.
211 PYTHON=`sed -e '1{
212 s/^#!//
214 }' ../git-merge-recursive` || {
215 error "You haven't built things yet, have you?"
217 "$PYTHON" -c 'import subprocess' 2>/dev/null || {
218 PYTHONPATH=$(pwd)/../compat
219 export PYTHONPATH
221 test -d ../templates/blt || {
222 error "You haven't built things yet, have you?"
225 # Test repository
226 test=trash
227 rm -fr "$test"
228 test_create_repo $test
229 cd "$test"